local Sorcerer = ...

-- Register prefab nodes (currently only one core model)
Sorcerer:registerAssetId("models/sorcerer.fbx/Prefab/sorcerer/housePart", "SORCERER_HOUSE_PREFAB")

Sorcerer:register({
--Dclare que l'objet que l'on cre appartient  la class BUILDING
	DataType = "BUILDING",
--Dclare la classe de l'objet que l'on cre
	Id = "SORCERER_HOUSE",
	Name = "SORCERER_HOUSE_NAME",
	Description = "SORCERER_HOUSE_DESC",
--Renseigne le champ Building Type. cela va permettre de classer l'objet dans les menus
	BuildingType = "DECORATION",
--renseigne le champ BuildingPartList de l'objet que l'on cre un peu plus loin	
	BuildingPartList = { "SORCERER_HOUSE_PART" },
--Renseigne le champ Nombre de villageois requis pour la construction. Ici inactiv pour le test
	--VillagerRequired = { Status = "NEWCOMER", Quantity = 9 }
})


-- Register the sorcerer house part
Sorcerer:register({
	DataType = "BUILDING_PART",
	Id = "SORCERER_HOUSE_PART",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "SORCERER_HOUSE_PREFAB"
	},
--Dclaration de la taille de la zone de construction ( c'est un masque qui cache la zone de futur construction pour faire passer devant le decor votre object" veiller a la faire a la bonne taille ..pas bloquant
	BuildingZone = { 4, 4},
--Ca c'est pour dclarer le visuel de construction si il y en a un !
	ConstructionVisual = "SORCERER_HOUSE_PREFAB",
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		},
		RessourcesNeeded = { -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "WOOD", Quantity = 5 }
		}
	},
	BuildingFunction = {
		DataType = "BUILDING_FUNCTION_WORKPLACE",
		WorkerCapacity = 1,
                RelatedJob = { Job = "SORCERER", Behavior = "WORK_BEHAVIOR" },
                InputInventoryCapacity = {
			{ Resource = "BERRIES", Quantity = 1 }
                },
                ResourceListNeeded = {
			{ Resource = "BERRIES", Quantity = 1 }
                },
                ResourceProduced = {
			{ Resource = "BERRIES", Quantity = 1 }
                }
	}
})

-- Register flag assigner component on the collider's type to 'PLATFORM'

Sorcerer:configurePrefabFlagList("models/sorcerer.fbx/Prefab/sorcerer/housePart", { "PLATFORM" })

Sorcerer:registerAssetId("models/sorcerer.fbx/Prefab/sorcerer/housePart/step_0/SmokeEmitter", "SORCERER_SMOKE_EMITTER_PREFAB")
Sorcerer:registerAssetId("models/sorcerer.fbx/Prefab/sorcerer/housePart/step_0/BatEmitter", "SORCERER_BAT_EMITTER_PREFAB")

Sorcerer:registerPrefabComponent("models/sorcerer.fbx/Prefab/sorcerer/housePart", {
	DataType = "COMP_BUILDING_PART",
	FeedbackComponentListToActivate = {
                 { "SORCERER_SMOKE_EMITTER_PREFAB", "COMP_PARTICLE_EMITTER_TOGGLE" },
                 { "SORCERER_BAT_EMITTER_PREFAB", "COMP_PARTICLE_EMITTER_TOGGLE" }
	}
})

-- Register air vent particle system
Sorcerer:registerPrefabComponent("models/sorcerer.fbx/Prefab/sorcerer/housePart/step_0/SmokeEmitter", {
	DataType = "COMP_PARTICLE_EMITTER",
	ParticleSystem = "PARTICLE_SYSTEM_STONECUTTER_ROCK",
	IsPlaying = true,
	IsEmitting = false
})

Sorcerer:registerPrefabComponent("models/sorcerer.fbx/Prefab/sorcerer/housePart/step_0/SmokeEmitter", {
	DataType = "COMP_PARTICLE_EMITTER_TOGGLE",
	Enabled = false
})

-- Register air vent particle system
Sorcerer:registerPrefabComponent("models/sorcerer.fbx/Prefab/sorcerer/housePart/step_0/BatEmitter", {
	DataType = "COMP_PARTICLE_EMITTER",
	ParticleSystem = "BAT_PARTICLE_SYSTEM",
	IsPlaying = true,
	IsEmitting = false
})

Sorcerer:registerPrefabComponent("models/sorcerer.fbx/Prefab/sorcerer/housePart/step_0/BatEmitter", {
	DataType = "COMP_PARTICLE_EMITTER_TOGGLE",
	Enabled = false
})
